/**************************************************************************//**
 * @file		 main.c
 * @version	V1.00
 * @brief		Show how to set GPIO pin to control AL58263.
 *
 * SPDX-License-Identifier: Apache-2.0
 * @copyright (C) 2023 xxxxxxxx Technology Corp. All rights reserved.
 ******************************************************************************/
#include "stdio.h"
#include "NuMicro.h"
#include <string.h>
#include <stdio.h>
#include <stdlib.h>


#define QTY_LED				16
#define Number_Colors 3
#define Index_Blue		2
#define Index_Green 	1
#define Index_Red			0
#define TimeDelay1 1
#define TimeDelay2 24
#define MaxBright				60000
#define Show1BrightStep	36
#define Show2BrightStep 88
#define Show3BrightStep 120
#define Show6BrightStep 120
#define Delay_us();		CLK_SysTickDelay(1);
#define Delay_10us();		CLK_SysTickDelay(10);
#define Delay_100us();		CLK_SysTickDelay(100);
/*---------------------------------------------------------------------------------------------------------*/
#define Dout					PB5
#define Dck						PB6
#define Din						PB4
#define Latch					PC2
/*---------------------------------------------------------------------------------------------------------*/
#define Din_HI()	Din=1;
#define Din_LO()	Din=0
#define Dck_HI() Dck = 1;
#define Dck_LO() Dck = 0
#define Latch_HI() Latch = 1;
#define Latch_LO() Latch = 0
#define DckPulse() 	Dck_HI();Dck_LO()
#define LatchPulse() 	Latch_HI();Latch_LO()
/*---------------------------------------------------------------------------------------------------------*/
volatile  uint16_t LEDBuf1[QTY_LED][Number_Colors];
static  	uint16_t FullColor[QTY_LED * 2][Number_Colors] =
{   {MaxBright, 0, 0},
    {MaxBright, MaxBright * 0.2, 0},
    {MaxBright, MaxBright * 0.45, MaxBright * 0.02},
    {0, MaxBright, 0},
    {0, MaxBright, MaxBright * 0.3},
    {0, MaxBright, MaxBright * 0.6},
    {0, MaxBright, MaxBright},
    {0, MaxBright * 0.6, MaxBright},
    {0, MaxBright * 0.3, MaxBright},
    {0, 0, MaxBright},
    {MaxBright * 0.3, 0, MaxBright},
    {MaxBright * 0.6, 0, MaxBright},
    {MaxBright, 0, MaxBright},
    {MaxBright, MaxBright * 0.3, MaxBright},
    {MaxBright, MaxBright * 0.6, MaxBright},
    {MaxBright, MaxBright, MaxBright},
    {MaxBright, 0, 0},
    {MaxBright, MaxBright * 0.2, 0},
    {MaxBright, MaxBright * 0.45, MaxBright * 0.02},
    {0, MaxBright, 0},
    {0, MaxBright, MaxBright * 0.3},
    {0, MaxBright, MaxBright * 0.6},
    {0, MaxBright, MaxBright},
    {0, MaxBright * 0.6, MaxBright},
    {0, MaxBright * 0.3, MaxBright},
    {0, 0, MaxBright},
    {MaxBright * 0.3, 0, MaxBright},
    {MaxBright * 0.6, 0, MaxBright},
    {MaxBright, 0, MaxBright},
    {MaxBright, MaxBright * 0.3, MaxBright},
    { MaxBright, MaxBright * 0.6, MaxBright},
    {MaxBright, MaxBright, MaxBright}
};

volatile  uint16_t ICCMD;
volatile  uint8_t SwitchVlaue[2];

/*---------------------------------------------------------------------------------------------------------*/
extern void M0A23OC_SYS_Init(void);
extern void M0A23OC_Pin_init(void);
/*---------------------------------------------------------------------------------------------------------*/
void SHiftDataOut(uint16_t y0) {
    Latch_LO();
    Din_LO();
    Dck_LO();

    if(y0 & 0x08000) {
        Din_HI();
    } else {
        Din_LO();
    }

    DckPulse();

    if(y0 & 0x04000) {
        Din_HI();
    } else {
        Din_LO();
    }

    DckPulse();

    if(y0 & 0x02000) {
        Din_HI();
    } else {
        Din_LO();
    }

    DckPulse();

    if(y0 & 0x01000) {
        Din_HI();
    } else {
        Din_LO();
    }

    DckPulse();

    if(y0 & 0x0800) {
        Din_HI();
    } else {
        Din_LO();
    }

    DckPulse();

    if(y0 & 0x0400) {
        Din_HI();
    } else {
        Din_LO();
    }

    DckPulse();

    if(y0 & 0x0200) {
        Din_HI();
    } else {
        Din_LO();
    }

    DckPulse();

    if(y0 & 0x0100) {
        Din_HI();
    } else {
        Din_LO();
    }

    DckPulse();

    if(y0 & 0x080) {
        Din_HI();
    } else {
        Din_LO();
    }

    DckPulse();

    if(y0 & 0x040) {
        Din_HI();
    } else {
        Din_LO();
    }

    DckPulse();

    if(y0 & 0x020) {
        Din_HI();
    } else {
        Din_LO();
    }

    DckPulse();

    if(y0 & 0x010) {
        Din_HI();
    } else {
        Din_LO();
    }

    DckPulse();

    if(y0 & 0x08) {
        Din_HI();
    } else {
        Din_LO();
    }

    DckPulse();

    if(y0 & 0x04) {
        Din_HI();
    } else {
        Din_LO();
    }

    DckPulse();

    if(y0 & 0x02) {
        Din_HI();
    } else {
        Din_LO();
    }

    DckPulse();

    if(y0 & 0x01) {
        Din_HI();
    } else {
        Din_LO();
    }

    DckPulse();
    Din_LO();

}

/*---------------------------------------------------------------------------------------------------------*/
void EndCMD(void) {
    Latch_LO();
    Dck_HI();
    Dck_LO();
}

//----------------------------------------------
void CmdDataLatch(void) {
    Dck_LO();
    Latch_LO();
    Latch_HI();
}

//----------------------------------------------
void CmdGlobalLatch(void) {
    uint16_t i;
    Latch_LO();

    for (i = 0; i < 14; i++) {
        Dck_HI();
        Dck_LO();
    }

    Latch_HI();
    Dck_HI();
    Dck_LO();
    Dck_HI();
    Dck_LO();
    Latch_LO();
}

//----------------------------------------------
void CmdReadingImageDataAndCommandData(void) {
    uint16_t i;
    Latch_LO();

    for (i = 0; i < 10; i++) {
        Dck_HI();
        Dck_LO();
    }

    Latch_LO();

    for (i = 0; i < 6; i++) {
        Dck_HI();
        Dck_LO();
    }

    Latch_LO();
}

//----------------------------------------------
void CmdReturnToNormalMode(void) {
    uint16_t i;
    Latch_LO();

    for (i = 0; i < 8; i++) {
        Dck_HI();
        Dck_LO();
    }

    Latch_LO();

    for (i = 0; i < 8; i++) {
        Dck_HI();
        Dck_LO();
    }

    Latch_LO();
}

//----------------------------------------------
void CmdWritingCommand(uint16_t y1) {
    Latch_LO();
    Din_LO();
    Dck_LO();

    if(y1 & 0x08000) {
        Din_HI();
    } else {
        Din_LO();
    }

    DckPulse();

    if(y1 & 0x04000) {
        Din_HI();
    } else {
        Din_LO();
    }

    DckPulse();

    if(y1 & 0x02000) {
        Din_HI();
    } else {
        Din_LO();
    }

    DckPulse();

    if(y1 & 0x01000) {
        Din_HI();
    } else {
        Din_LO();
    }

    DckPulse();

    if(y1 & 0x0800) {
        Din_HI();
    } else {
        Din_LO();
    }

    DckPulse();

    if(y1 & 0x0400) {
        Din_HI();
    } else {
        Din_LO();
    }

    DckPulse();
    Latch_HI();

    if(y1 & 0x0200) {
        Din_HI();
    } else {
        Din_LO();
    }

    DckPulse();

    if(y1 & 0x0100) {
        Din_HI();
    } else {
        Din_LO();
    }

    DckPulse();

    if(y1 & 0x080) {
        Din_HI();
    } else {
        Din_LO();
    }

    DckPulse();

    if(y1 & 0x040) {
        Din_HI();
    } else {
        Din_LO();
    }

    DckPulse();

    if(y1 & 0x020) {
        Din_HI();
    } else {
        Din_LO();
    }

    DckPulse();

    if(y1 & 0x010) {
        Din_HI();
    } else {
        Din_LO();
    }

    DckPulse();

    if(y1 & 0x08) {
        Din_HI();
    } else {
        Din_LO();
    }

    DckPulse();

    if(y1 & 0x04) {
        Din_HI();
    } else {
        Din_LO();
    }

    DckPulse();

    if(y1 & 0x02) {
        Din_HI();
    } else {
        Din_LO();
    }

    DckPulse();

    if(y1 & 0x01) {
        Din_HI();
    } else {
        Din_LO();
    }

    DckPulse();
    Din_LO();
    Latch_LO();
}

//----------------------------------------------
void CmdResetPwmCounter(void) {
    uint16_t i;
    Latch_LO();

    for (i = 0; i < 4; i++) {
        Dck_HI();
        Dck_LO();
    }

    Latch_LO();

    for (i = 0; i < 12; i++) {
        Dck_HI();
        Dck_LO();
    }

    Latch_LO();
}

//----------------------------------------------
void CleanCMDBuffer(void) {
    uint16_t CMD = 0, i;
    CmdResetPwmCounter();	//Reset IC CMD銆�Data
    Latch_LO();

    for (i = 0; i < (int16_t) (32); i++) {
        Dck_HI();
        Dck_LO();
    }

    CmdWritingCommand(CMD);
}


//-----------------------------------------------------
void LEDOutput(void) {
    uint16_t i;
    SHiftDataOut(ICCMD);
    SHiftDataOut(ICCMD);
    CmdWritingCommand(ICCMD);
    EndCMD();
    Latch_LO();

        //1
        SHiftDataOut(LEDBuf1[0][Index_Green]);
        SHiftDataOut(LEDBuf1[5][Index_Red]);
        SHiftDataOut(LEDBuf1[10][Index_Blue]);
        LatchPulse();
        //2
        SHiftDataOut(LEDBuf1[0][Index_Red]);
        SHiftDataOut(LEDBuf1[5][Index_Blue]);
        SHiftDataOut(LEDBuf1[11][Index_Green]);
        LatchPulse();
        //3
        SHiftDataOut(LEDBuf1[0][Index_Blue]);
        SHiftDataOut(LEDBuf1[6][Index_Green]);
        SHiftDataOut(LEDBuf1[11][Index_Red]);
        LatchPulse();
        //4
        SHiftDataOut(LEDBuf1[1][Index_Green]);
        SHiftDataOut(LEDBuf1[6][Index_Red]);
        SHiftDataOut(LEDBuf1[11][Index_Blue]);
        LatchPulse();
        //5
        SHiftDataOut(LEDBuf1[1][Index_Red]);
        SHiftDataOut(LEDBuf1[6][Index_Blue]);
        SHiftDataOut(LEDBuf1[12][Index_Green]);
        LatchPulse();
        //6
        SHiftDataOut(LEDBuf1[1][Index_Blue]);
        SHiftDataOut(LEDBuf1[7][Index_Green]);
        SHiftDataOut(LEDBuf1[12][Index_Red]);
        LatchPulse();
        //7
        SHiftDataOut(LEDBuf1[2][Index_Green]);
        SHiftDataOut(LEDBuf1[7][Index_Red]);
        SHiftDataOut(LEDBuf1[12][Index_Blue]);
        LatchPulse();
        //8
        SHiftDataOut(LEDBuf1[2][Index_Red]);
        SHiftDataOut(LEDBuf1[7][Index_Blue]);
        SHiftDataOut(LEDBuf1[13][Index_Green]);
        LatchPulse();
        //9
        SHiftDataOut(LEDBuf1[2][Index_Blue]);
        SHiftDataOut(LEDBuf1[8][Index_Green]);
        SHiftDataOut(LEDBuf1[13][Index_Red]);
        LatchPulse();
        //10
        SHiftDataOut(LEDBuf1[3][Index_Green]);
        SHiftDataOut(LEDBuf1[8][Index_Red]);
        SHiftDataOut(LEDBuf1[13][Index_Blue]);
        LatchPulse();
        //11
        SHiftDataOut(LEDBuf1[3][Index_Red]);
        SHiftDataOut(LEDBuf1[8][Index_Blue]);
        SHiftDataOut(LEDBuf1[14][Index_Green]);
        LatchPulse();
        //12
        SHiftDataOut(LEDBuf1[3][Index_Blue]);
        SHiftDataOut(LEDBuf1[9][Index_Green]);
        SHiftDataOut(LEDBuf1[14][Index_Red]);
        LatchPulse();
        //13
        SHiftDataOut(LEDBuf1[4][Index_Green]);
        SHiftDataOut(LEDBuf1[9][Index_Red]);
        SHiftDataOut(LEDBuf1[14][Index_Blue]);
        LatchPulse();
        //14
        SHiftDataOut(LEDBuf1[4][Index_Red]);
        SHiftDataOut(LEDBuf1[9][Index_Blue]);
        SHiftDataOut(LEDBuf1[15][Index_Green]);
        LatchPulse();
        //15
        SHiftDataOut(LEDBuf1[4][Index_Blue]);
        SHiftDataOut(LEDBuf1[10][Index_Green]);
        SHiftDataOut(LEDBuf1[15][Index_Red]);
        LatchPulse();
        //16
        SHiftDataOut(LEDBuf1[5][Index_Green]);
        SHiftDataOut(LEDBuf1[10][Index_Red]);
        SHiftDataOut(LEDBuf1[15][Index_Blue]);
        LatchPulse();
				
    CmdGlobalLatch();
    CmdResetPwmCounter();
    EndCMD();

}

//-----------------------------------------------------
void CleanDataBuffer1(void) {
    uint16_t i;

    for (i = 0; i < QTY_LED; i++) {
        LEDBuf1[i][Index_Blue] = 0;
        LEDBuf1[i][Index_Green] = 0;
        LEDBuf1[i][Index_Red] = 0;
    }

    LEDOutput();
}

//-----------------------------------------------------
void delay_ms(uint16_t nDelay) {
    uint16_t nIndex;

    for (nIndex = 0; nIndex < nDelay; nIndex++) {
        CLK_SysTickDelay(1000);
    }
}

/*---------------------------------------------------------------------------------------------------------*/
/* Enable Gck @ PWM0 -> Pin PB.7						 */
/*---------------------------------------------------------------------------------------------------------*/
void EnableGck(void) {
    /* PWM0 channel 0 frequency is	Hz, duty 50%, */
    PWM_ConfigOutputChannel(PWM0, 0, 6000000, 45);
    /* Enable output of PWM0 channel 0 */
    PWM_EnableOutput(PWM0, PWM_CH_0_MASK);
    /* ZeroLevel: High, CmpUpLevel: nothing, PeriodLevel: nothing, CmpDownLevel: Low */
    PWM_SET_OUTPUT_LEVEL(PWM0, PWM_CH_0_MASK, PWM_OUTPUT_NOTHING,
                         PWM_OUTPUT_NOTHING, PWM_OUTPUT_HIGH, PWM_OUTPUT_LOW);
    /* Start PWM counter */
    PWM_Start(PWM0, PWM_CH_0_MASK);
}

/*---------------------------------------------------------------------------------------------------------*/
/* Disable Gck							*/
/*---------------------------------------------------------------------------------------------------------*/
void DisableGck(void) {
    /* Stop PWM counter */
    PWM_Stop(PWM0, PWM_CH_0_MASK);
    /* Disable output of PWM0 channel 0 */
    PWM_DisableOutput(PWM0, PWM_CH_0_MASK);
}

/*---------------------------------------------------------------------------------------------------------*/
//LED gradually dimming display (Fading in )----------------------------------------------
void Show1(void) {
    uint16_t i, j, k, l;
    l = 66;
    CleanDataBuffer1();

// Red	FIFO
    for (i = 0; i < Show1BrightStep; i++) {
        for (k = 0; k < l; k++) {
            for (j = 0; j < QTY_LED ; j++) {
                LEDBuf1[j][Index_Red] = i * MaxBright / Show1BrightStep;
                LEDBuf1[j][Index_Green] = 0;
                LEDBuf1[j][Index_Blue] = 0;
            }

            LEDOutput();
        }
    }

    for (i = Show1BrightStep; i > 0; i--) {
        for (k = 0; k < l; k++) {
            for (j = 0; j < QTY_LED ; j++) {
                LEDBuf1[j][Index_Red] = i * MaxBright / Show1BrightStep;
                LEDBuf1[j][Index_Green] = 0;
                LEDBuf1[j][Index_Blue] = 0;
            }

            LEDOutput();
        }
    }

//Amber FIFO
    for (i = 0; i < Show1BrightStep; i++) {
        for (k = 0; k < l; k++) {
            for (j = 0; j < QTY_LED ; j++) {
                LEDBuf1[j][Index_Red] = i * MaxBright / Show1BrightStep;
                LEDBuf1[j][Index_Green] = i * 24000 / Show1BrightStep;
                LEDBuf1[j][Index_Blue] = 0;
            }

            LEDOutput();
        }
    }

    for (i = Show1BrightStep; i > 0; i--) {
        for (k = 0; k < l; k++) {
            for (j = 0; j < QTY_LED ; j++) {
                LEDBuf1[j][Index_Red] = i * MaxBright / Show1BrightStep;
                LEDBuf1[j][Index_Green] = i * 24000 / Show1BrightStep;
                LEDBuf1[j][Index_Blue] = 0;
            }

            LEDOutput();
        }
    }

// Green	FIFO
    for (i = 0; i < Show1BrightStep; i++) {
        for (k = 0; k < l; k++) {
            for (j = 0; j < QTY_LED ; j++) {
                LEDBuf1[j][Index_Red] = 0;
                LEDBuf1[j][Index_Green] = i * MaxBright / Show1BrightStep;
                LEDBuf1[j][Index_Blue] = 0;
            }

            LEDOutput();
        }
    }

    for (i = Show1BrightStep; i > 0; i--) {
        for (k = 0; k < l; k++) {
            for (j = 0; j < QTY_LED ; j++) {
                LEDBuf1[j][Index_Red] = 0;
                LEDBuf1[j][Index_Green] = i * MaxBright / Show1BrightStep;
                LEDBuf1[j][Index_Blue] = 0;
            }

            LEDOutput();
        }
    }

// Cyan	FIFO
    for (i = 0; i < Show1BrightStep; i++) {
        for (k = 0; k < l; k++) {
            for (j = 0; j < QTY_LED ; j++) {
                LEDBuf1[j][Index_Red] = 0;
                LEDBuf1[j][Index_Green] = i * MaxBright / Show1BrightStep;
                LEDBuf1[j][Index_Blue] = i * MaxBright / Show1BrightStep;
            }

            LEDOutput();
        }
    }

    for (i = Show1BrightStep; i > 0; i--) {
        for (k = 0; k < l; k++) {
            for (j = 0; j < QTY_LED ; j++) {
                LEDBuf1[j][Index_Red] = 0;
                LEDBuf1[j][Index_Green] = i * MaxBright / Show1BrightStep;
                LEDBuf1[j][Index_Blue] = i * MaxBright / Show1BrightStep;
            }

            LEDOutput();
        }
    }


// Blue	FIFO
    for (i = 0; i < Show1BrightStep; i++) {
        for (k = 0; k < l; k++) {
            for (j = 0; j < QTY_LED ; j++) {
                LEDBuf1[j][Index_Red] = 0;
                LEDBuf1[j][Index_Green] = 0;
                LEDBuf1[j][Index_Blue] = i * MaxBright / Show1BrightStep;
            }

            LEDOutput();
        }
    }

    for (i = Show1BrightStep; i > 0; i--) {
        for (k = 0; k < l; k++) {
            for (j = 0; j < QTY_LED ; j++) {
                LEDBuf1[j][Index_Red] = 0;
                LEDBuf1[j][Index_Green] = 0;
                LEDBuf1[j][Index_Blue] = i * MaxBright / Show1BrightStep;
            }

            LEDOutput();
        }
    }

// violet	FIFO
    for (i = 0; i < Show1BrightStep; i++) {
        for (k = 0; k < l; k++) {
            for (j = 0; j < QTY_LED ; j++) {
                LEDBuf1[j][Index_Red] = i * MaxBright / Show1BrightStep;
                LEDBuf1[j][Index_Green] = 0;
                LEDBuf1[j][Index_Blue] = i * MaxBright / Show1BrightStep;
            }

            LEDOutput();
        }
    }

    for (i = Show1BrightStep; i > 0; i--) {
        for (k = 0; k < l; k++) {
            for (j = 0; j < QTY_LED ; j++) {
                LEDBuf1[j][Index_Red] = i * MaxBright / Show1BrightStep;
                LEDBuf1[j][Index_Green] = 0;
                LEDBuf1[j][Index_Blue] = i * MaxBright / Show1BrightStep;
            }

            LEDOutput();
        }
    }

    return;
}

//LED gradually dimming display ----------------------------------------------
void Show2(void) {
    uint16_t i, j, k, l;
    l = 88;
    CleanDataBuffer1();

    for (i = 0; i < Show2BrightStep; i++) {
        for (k = 0; k < l; k++) {
            for (j = 0; j < QTY_LED ; j++) {
                LEDBuf1[j][Index_Red] = i * MaxBright / Show2BrightStep;
                LEDBuf1[j][Index_Green] = 0;
                LEDBuf1[j][Index_Blue] = (Show2BrightStep - i)
                                         * MaxBright / Show2BrightStep;
            }

            LEDOutput();
        }
    }

    for (i = 0; i < Show2BrightStep; i++) {
        for (k = 0; k < l; k++) {
            for (j = 0; j < QTY_LED ; j++) {
                LEDBuf1[j][Index_Red] = (Show2BrightStep - i)
                                        * MaxBright / Show2BrightStep;
                LEDBuf1[j][Index_Green] = i * MaxBright / Show2BrightStep;
                LEDBuf1[j][Index_Blue] = 0;
            }

            LEDOutput();
        }
    }

    for (i = 0; i < Show2BrightStep; i++) {
        for (k = 0; k < l; k++) {
            for (j = 0; j < QTY_LED ; j++) {
                LEDBuf1[j][Index_Red] = 0;
                LEDBuf1[j][Index_Green] = (Show2BrightStep - i)
                                          * MaxBright / Show2BrightStep;
                LEDBuf1[j][Index_Blue] = i * MaxBright / Show2BrightStep;
            }

            LEDOutput();
        }
    }

    for (i = 0; i < Show2BrightStep; i++) {
        for (k = 0; k < l; k++) {
            for (j = 0; j < QTY_LED ; j++) {
                LEDBuf1[j][Index_Red] = i * MaxBright / Show2BrightStep;
                LEDBuf1[j][Index_Green] = 0;
                LEDBuf1[j][Index_Blue] = (Show2BrightStep - i)
                                         * MaxBright / Show2BrightStep;
            }

            LEDOutput();
        }
    }

    return;
}

//LED Show Marquee 1-16 ----------------------------------------------
void Show3(void) {
    int16_t i, j;

    CleanDataBuffer1();

    for (j = 15; j > -1; j--) {
        for (i = 0; i < Show3BrightStep; i++) {
            LEDBuf1[j][Index_Red] = i * MaxBright / Show3BrightStep;
            LEDBuf1[j][Index_Green] = 0;
            LEDBuf1[j][Index_Blue] = 0;
            LEDOutput();
        }
    }

    for (j = 15; j > -1; j--) {
        for (i = 0; i < Show3BrightStep; i++) {
            LEDBuf1[j][Index_Red] = i * MaxBright / Show3BrightStep;
            LEDBuf1[j][Index_Green] = i * MaxBright / Show3BrightStep * 0.25;
            LEDBuf1[j][Index_Blue] = 0;
            LEDOutput();
        }
    }

    for (j = 15; j > -1; j--) {
        for (i = 0; i < Show3BrightStep; i++) {
            LEDBuf1[j][Index_Red] = i * MaxBright / Show3BrightStep;
            LEDBuf1[j][Index_Green] = i * MaxBright / Show3BrightStep * 0.45;
            LEDBuf1[j][Index_Blue] = i * MaxBright / Show3BrightStep * 0.05;
            LEDOutput();
        }
    }

    for (j = 15; j > -1; j--) {
        for (i = 0; i < Show3BrightStep; i++) {
            LEDBuf1[j][Index_Red] = (Show3BrightStep - i) * MaxBright / Show3BrightStep;
            LEDBuf1[j][Index_Green] = i * MaxBright / Show3BrightStep;
            LEDBuf1[j][Index_Blue] = 0;
            LEDOutput();
        }
    }

    for (j = 15; j > -1; j--) {
        for (i = 0; i < Show3BrightStep; i++) {
            LEDBuf1[j][Index_Red] = 0;
            LEDBuf1[j][Index_Green] = i * MaxBright / Show3BrightStep;
            LEDBuf1[j][Index_Blue] = i * MaxBright / Show3BrightStep;
            LEDOutput();
        }
    }

    for (j = 15; j > -1; j--) {
        for (i = 0; i < Show3BrightStep; i++) {
            LEDBuf1[j][Index_Red] = i * MaxBright / Show3BrightStep;
            LEDBuf1[j][Index_Green] = 0;
            LEDBuf1[j][Index_Blue] = i * MaxBright / Show3BrightStep * 0.8;
            LEDOutput();
        }
    }

    for (j = 15; j > -1; j--) {
        for (i = 0; i < Show3BrightStep; i++) {
            LEDBuf1[j][Index_Red] = 0;
            LEDBuf1[j][Index_Green] = 0;
            LEDBuf1[j][Index_Blue] = 0;
            LEDOutput();
        }
    }

    return;
}

//LED Show Marquee 16-1 ----------------------------------------------
void Show4(void) {
    uint16_t i, j;

    CleanDataBuffer1();

    for (j = 0; j < QTY_LED ; j++) {
        for (i = 0; i < Show3BrightStep; i++) {
            LEDBuf1[j][Index_Red] = i * MaxBright / Show3BrightStep;
            LEDBuf1[j][Index_Green] = 0;
            LEDBuf1[j][Index_Blue] = 0;
            LEDOutput();
        }
    }

    for (j = 0; j < QTY_LED ; j++) {
        for (i = 0; i < Show3BrightStep; i++) {
            LEDBuf1[j][Index_Red] = i * MaxBright / Show3BrightStep;
            LEDBuf1[j][Index_Green] = i * MaxBright / Show3BrightStep * 0.25;
            LEDBuf1[j][Index_Blue] = 0 ;
            LEDOutput();
        }
    }

    for (j = 0; j < QTY_LED ; j++) {
        for (i = 0; i < Show3BrightStep; i++) {
            LEDBuf1[j][Index_Red] = i * MaxBright / Show3BrightStep;
            LEDBuf1[j][Index_Green] = i * MaxBright / Show3BrightStep * 0.45;
            LEDBuf1[j][Index_Blue] = i * MaxBright / Show3BrightStep * 0.05;
            LEDOutput();
        }
    }

    for (j = 0; j < QTY_LED ; j++) {
        for (i = 0; i < Show3BrightStep; i++) {
            LEDBuf1[j][Index_Red] = (Show3BrightStep - i) * MaxBright / Show3BrightStep;
            LEDBuf1[j][Index_Green] = i * MaxBright / Show3BrightStep;
            LEDBuf1[j][Index_Blue] = 0;
            LEDOutput();
        }
    }

    for (j = 0; j < QTY_LED ; j++) {
        for (i = 0; i < Show3BrightStep; i++) {
            LEDBuf1[j][Index_Red] = 0;
            LEDBuf1[j][Index_Green] = i * MaxBright / Show3BrightStep;
            LEDBuf1[j][Index_Blue] = i * MaxBright / Show3BrightStep;
            LEDOutput();
        }
    }

    for (j = 0; j < QTY_LED ; j++) {
        for (i = 0; i < Show3BrightStep; i++) {
            LEDBuf1[j][Index_Red] = i * MaxBright / Show3BrightStep;
            LEDBuf1[j][Index_Green] = 0;
            LEDBuf1[j][Index_Blue] = i * MaxBright / Show3BrightStep * 0.8;
            LEDOutput();
        }
    }

    for (j = 0; j < QTY_LED ; j++) {
        for (i = 0; i < Show3BrightStep; i++) {
            LEDBuf1[j][Index_Red] = 0;
            LEDBuf1[j][Index_Green] = 0;
            LEDBuf1[j][Index_Blue] = 0;
            LEDOutput();
        }
    }

    return;
}

//LED Show Full Color Marquee ----------------------------------------------
void Show5(void) {
    uint16_t i, j, k;

    for (k = 0; k < QTY_LED; k++) {
        CleanDataBuffer1();

        for (j = 0; j < QTY_LED; j++) {
            for (i = 0; i < Number_Colors; i++) {
                LEDBuf1[j][i] = FullColor[j + k][i];
            }
        }

        LEDOutput();
        delay_ms(88);
    }

    return;
}

//LED Meteor rain in Setup -------------------------------------------
void MeteorRainLightInSetup(uint16_t PosIndex, uint16_t RColor, uint16_t GColor, uint16_t BColor) {

    LEDBuf1[PosIndex][Index_Red] = RColor;
    LEDBuf1[PosIndex][Index_Green] = GColor;
    LEDBuf1[PosIndex][Index_Blue] = BColor;

    if(PosIndex == 1) {
        LEDBuf1[0][Index_Red] = RColor * 0.67;
        LEDBuf1[0][Index_Green] = GColor * 0.67;
        LEDBuf1[0][Index_Blue] = BColor * 0.67;
    }

    if(PosIndex == 2) {
        LEDBuf1[1][Index_Red] = RColor * 0.67;
        LEDBuf1[0][Index_Red] = RColor * 0.27;
        LEDBuf1[1][Index_Green] = GColor * 0.67;
        LEDBuf1[0][Index_Green] = GColor * 0.27;
        LEDBuf1[1][Index_Blue] = BColor * 0.67;
        LEDBuf1[0][Index_Blue] = BColor * 0.27;

    }

    if(PosIndex == 3) {
        LEDBuf1[2][Index_Red] = RColor * 0.67;
        LEDBuf1[1][Index_Red] = RColor * 0.27;
        LEDBuf1[0][Index_Red] = RColor * 0.05;

        LEDBuf1[2][Index_Green] = GColor * 0.67;
        LEDBuf1[1][Index_Green] = GColor * 0.27;
        LEDBuf1[0][Index_Green] = GColor * 0.05;

        LEDBuf1[2][Index_Blue] = BColor * 0.67;
        LEDBuf1[1][Index_Blue] = BColor * 0.27;
        LEDBuf1[0][Index_Blue] = BColor * 0.05;

    }

    if(PosIndex >= 4) {
        LEDBuf1[PosIndex - 1][Index_Red] = RColor * 0.67;
        LEDBuf1[PosIndex - 2][Index_Red] = RColor * 0.27;
        LEDBuf1[PosIndex - 3][Index_Red] = RColor * 0.05;
        LEDBuf1[PosIndex - 4][Index_Red] = RColor * 0.01;

        LEDBuf1[PosIndex - 1][Index_Green] = GColor * 0.67;
        LEDBuf1[PosIndex - 2][Index_Green] = GColor * 0.27;
        LEDBuf1[PosIndex - 3][Index_Green] = GColor * 0.05;
        LEDBuf1[PosIndex - 4][Index_Green] = GColor * 0.01;

        LEDBuf1[PosIndex - 1][Index_Blue] = BColor * 0.67;
        LEDBuf1[PosIndex - 2][Index_Blue] = BColor * 0.27;
        LEDBuf1[PosIndex - 3][Index_Blue] = BColor * 0.05;
        LEDBuf1[PosIndex - 4][Index_Blue] = BColor * 0.01;

    }
}

//LED Meteor rain in Setup -------------------------------------------
void MeteorRainLightOutSetup(uint16_t PosIndex, uint16_t RColor, uint16_t GColor, uint16_t BColor) {

    LEDBuf1[PosIndex][Index_Red] = RColor;
    LEDBuf1[PosIndex][Index_Green] = GColor;
    LEDBuf1[PosIndex][Index_Blue] = BColor;

    if(PosIndex == 14) {
        LEDBuf1[15][Index_Red] = RColor * 0.67;
        LEDBuf1[15][Index_Green] = GColor * 0.67;
        LEDBuf1[15][Index_Blue] = BColor * 0.67;
    }

    if(PosIndex == 13) {
        LEDBuf1[14][Index_Red] = RColor * 0.67;
        LEDBuf1[15][Index_Red] = RColor * 0.27;
        LEDBuf1[14][Index_Green] = GColor * 0.67;
        LEDBuf1[15][Index_Green] = GColor * 0.27;
        LEDBuf1[14][Index_Blue] = BColor * 0.67;
        LEDBuf1[15][Index_Blue] = BColor * 0.27;

    }

    if(PosIndex == 12) {
        LEDBuf1[13][Index_Red] = RColor * 0.67;
        LEDBuf1[14][Index_Red] = RColor * 0.27;
        LEDBuf1[15][Index_Red] = RColor * 0.05;

        LEDBuf1[13][Index_Green] = GColor * 0.67;
        LEDBuf1[14][Index_Green] = GColor * 0.27;
        LEDBuf1[15][Index_Green] = GColor * 0.05;

        LEDBuf1[13][Index_Blue] = BColor * 0.67;
        LEDBuf1[14][Index_Blue] = BColor * 0.27;
        LEDBuf1[15][Index_Blue] = BColor * 0.05;

    }

    if(PosIndex <= 11) {
        LEDBuf1[PosIndex + 1][Index_Red] = RColor * 0.67;
        LEDBuf1[PosIndex + 2][Index_Red] = RColor * 0.27;
        LEDBuf1[PosIndex + 3][Index_Red] = RColor * 0.05;
        LEDBuf1[PosIndex + 4][Index_Red] = RColor * 0.01;

        LEDBuf1[PosIndex + 1][Index_Green] = GColor * 0.67;
        LEDBuf1[PosIndex + 2][Index_Green] = GColor * 0.27;
        LEDBuf1[PosIndex + 3][Index_Green] = GColor * 0.05;
        LEDBuf1[PosIndex + 4][Index_Green] = GColor * 0.01;

        LEDBuf1[PosIndex + 1][Index_Blue] = BColor * 0.67;
        LEDBuf1[PosIndex + 2][Index_Blue] = BColor * 0.27;
        LEDBuf1[PosIndex + 3][Index_Blue] = BColor * 0.05;
        LEDBuf1[PosIndex + 4][Index_Blue] = BColor * 0.01;

    }

}

//LED Show Meteor rain light ----------------------------------------------
void Show6(void) {
    uint16_t i, j, k;

    j = rand();
    j %= 15;

    k = rand();
    k %= 48;
    k += 24;

    switch(j)
    {
        case 0:
            for (i = 0; i < QTY_LED; i++) {
                CleanDataBuffer1();
                MeteorRainLightInSetup(i, MaxBright, 0, 0);
                LEDOutput();
                delay_ms(k);
            }

            break;

        case 1:
            for (i = 0; i < QTY_LED; i++) {
                CleanDataBuffer1();
                MeteorRainLightInSetup(i, MaxBright, MaxBright / 3, 0);
                LEDOutput();
                delay_ms(k);
            }

            break;

        case 2:
            for (i = 0; i < QTY_LED; i++) {
                CleanDataBuffer1();
                MeteorRainLightInSetup(i, MaxBright, MaxBright * 2 / 3, MaxBright * 0.05);
                LEDOutput();
                delay_ms(k);
            }

            break;

        case 3:
            for (i = 0; i < QTY_LED; i++) {
                CleanDataBuffer1();
                MeteorRainLightInSetup(i, 0, MaxBright, 0);
                LEDOutput();
                delay_ms(k);
            }

            break;

        case 4:
            for (i = 0; i < QTY_LED; i++) {
                CleanDataBuffer1();
                MeteorRainLightInSetup(i, 0, MaxBright, MaxBright / 3);
                LEDOutput();
                delay_ms(k);
            }

            break;

        case 5:
            for (i = 0; i < QTY_LED; i++) {
                CleanDataBuffer1();
                MeteorRainLightInSetup(i, 0, MaxBright, MaxBright * 2 / 3);
                LEDOutput();
                delay_ms(k);
            }

            break;

        case 6:
            for (i = 0; i < QTY_LED; i++) {
                CleanDataBuffer1();
                MeteorRainLightInSetup(i, 0, MaxBright, MaxBright);
                LEDOutput();
                delay_ms(k);
            }

            break;

        case 7:
            for (i = 0; i < QTY_LED; i++) {
                CleanDataBuffer1();
                MeteorRainLightInSetup(i, 0, MaxBright * 2 / 3, MaxBright);
                LEDOutput();
                delay_ms(k);
            }

            break;

        case 8:
            for (i = 0; i < QTY_LED; i++) {
                CleanDataBuffer1();
                MeteorRainLightInSetup(i, 0, MaxBright / 3, MaxBright);
                LEDOutput();
                delay_ms(k);
            }

            break;

        case 9:
            for (i = 0; i < QTY_LED; i++) {
                CleanDataBuffer1();
                MeteorRainLightInSetup(i, 0, 0, MaxBright);
                LEDOutput();
                delay_ms(k);
            }

            break;

        case 10:
            for (i = 0; i < QTY_LED; i++) {
                CleanDataBuffer1();
                MeteorRainLightInSetup(i, MaxBright / 3, 0, MaxBright);
                LEDOutput();
                delay_ms(k);
            }

            break;

        case 11:
            for (i = 0; i < QTY_LED; i++) {
                CleanDataBuffer1();
                MeteorRainLightInSetup(i, MaxBright * 2 / 3, 0, MaxBright);
                LEDOutput();
                delay_ms(k);
            }

            break;

        case 12:
            for (i = 0; i < QTY_LED; i++) {
                CleanDataBuffer1();
                MeteorRainLightInSetup(i, MaxBright, 0, MaxBright);
                LEDOutput();
                delay_ms(k);
            }

            break;

        case 13:
            for (i = 0; i < QTY_LED; i++) {
                CleanDataBuffer1();
                MeteorRainLightInSetup(i, MaxBright, 0, MaxBright * 2 / 3);
                LEDOutput();
                delay_ms(k);
            }

            break;

        default :
            for (i = 0; i < QTY_LED; i++) {
                CleanDataBuffer1();
                MeteorRainLightInSetup(i, MaxBright, 0, MaxBright / 3);
                LEDOutput();
                delay_ms(k);
            }

            break;


    }

    return;
}




//LED Show Meteor rain light ----------------------------------------------
void Show7(void) {
    uint16_t i;

    for (i = 0; i < QTY_LED; i++) {
        CleanDataBuffer1();
        MeteorRainLightInSetup(i, MaxBright, 0, 0);
        LEDOutput();
        delay_ms(24);
    }

    for (i = 0; i < QTY_LED; i++) {
        CleanDataBuffer1();
        MeteorRainLightOutSetup(QTY_LED - i, MaxBright, 0, 0);
        LEDOutput();
        delay_ms(50);
    }

    for (i = 0; i < QTY_LED; i++) {
        CleanDataBuffer1();
        MeteorRainLightInSetup(i, MaxBright, MaxBright / 3, 0);
        LEDOutput();
        delay_ms(24);
    }

    for (i = 0; i < QTY_LED; i++) {
        CleanDataBuffer1();
        MeteorRainLightOutSetup(QTY_LED - i, MaxBright, MaxBright / 3, 0);
        LEDOutput();
        delay_ms(50);
    }

    for (i = 0; i < QTY_LED; i++) {
        CleanDataBuffer1();
        MeteorRainLightInSetup(i, MaxBright, MaxBright * 2 / 3, MaxBright * 0.05);
        LEDOutput();
        delay_ms(24);
    }

    for (i = 0; i < QTY_LED; i++) {
        CleanDataBuffer1();
        MeteorRainLightOutSetup(QTY_LED - i, MaxBright, MaxBright * 2 / 3, MaxBright * 0.05);
        LEDOutput();
        delay_ms(50);
    }

    for (i = 0; i < QTY_LED; i++) {
        CleanDataBuffer1();
        MeteorRainLightInSetup(i, 0, MaxBright, 0);
        LEDOutput();
        delay_ms(24);
    }

    for (i = 0; i < QTY_LED; i++) {
        CleanDataBuffer1();
        MeteorRainLightOutSetup(QTY_LED - i, 0, MaxBright, 0);
        LEDOutput();
        delay_ms(50);
    }

    for (i = 0; i < QTY_LED; i++) {
        CleanDataBuffer1();
        MeteorRainLightInSetup(i, 0, MaxBright, MaxBright / 3);
        LEDOutput();
        delay_ms(24);
    }

    for (i = 0; i < QTY_LED; i++) {
        CleanDataBuffer1();
        MeteorRainLightOutSetup(QTY_LED - i, 0, MaxBright, MaxBright / 3);
        LEDOutput();
        delay_ms(50);
    }

    for (i = 0; i < QTY_LED; i++) {
        CleanDataBuffer1();
        MeteorRainLightInSetup(i, 0, MaxBright, MaxBright * 2 / 3);
        LEDOutput();
        delay_ms(24);
    }

    for (i = 0; i < QTY_LED; i++) {
        CleanDataBuffer1();
        MeteorRainLightOutSetup(QTY_LED - i, 0, MaxBright, MaxBright * 2 / 3);
        LEDOutput();
        delay_ms(50);
    }

    for (i = 0; i < QTY_LED; i++) {
        CleanDataBuffer1();
        MeteorRainLightInSetup(i, 0, MaxBright, MaxBright);
        LEDOutput();
        delay_ms(24);
    }

    for (i = 0; i < QTY_LED; i++) {
        CleanDataBuffer1();
        MeteorRainLightOutSetup(QTY_LED - i, 0, MaxBright, MaxBright);
        LEDOutput();
        delay_ms(50);
    }

    for (i = 0; i < QTY_LED; i++) {
        CleanDataBuffer1();
        MeteorRainLightInSetup(i, 0, MaxBright * 2 / 3, MaxBright);
        LEDOutput();
        delay_ms(24);
    }

    for (i = 0; i < QTY_LED; i++) {
        CleanDataBuffer1();
        MeteorRainLightOutSetup(QTY_LED - i, 0, MaxBright * 2 / 3, MaxBright);
        LEDOutput();
        delay_ms(50);
    }

    for (i = 0; i < QTY_LED; i++) {
        CleanDataBuffer1();
        MeteorRainLightInSetup(i, 0, MaxBright / 3, MaxBright);
        LEDOutput();
        delay_ms(24);
    }

    for (i = 0; i < QTY_LED; i++) {
        CleanDataBuffer1();
        MeteorRainLightOutSetup(QTY_LED - i, 0, MaxBright / 3, MaxBright);
        LEDOutput();
        delay_ms(50);
    }

    for (i = 0; i < QTY_LED; i++) {
        CleanDataBuffer1();
        MeteorRainLightInSetup(i, 0, 0, MaxBright);
        LEDOutput();
        delay_ms(24);
    }

    for (i = 0; i < QTY_LED; i++) {
        CleanDataBuffer1();
        MeteorRainLightOutSetup(QTY_LED - i, 0, 0, MaxBright);
        LEDOutput();
        delay_ms(50);
    }

    for (i = 0; i < QTY_LED; i++) {
        CleanDataBuffer1();
        MeteorRainLightInSetup(i, MaxBright / 3, 0, MaxBright);
        LEDOutput();
        delay_ms(24);
    }

    for (i = 0; i < QTY_LED; i++) {
        CleanDataBuffer1();
        MeteorRainLightOutSetup(QTY_LED - i, MaxBright / 3, 0, MaxBright);
        LEDOutput();
        delay_ms(50);
    }

    for (i = 0; i < QTY_LED; i++) {
        CleanDataBuffer1();
        MeteorRainLightInSetup(i, MaxBright * 2 / 3, 0, MaxBright);
        LEDOutput();
        delay_ms(24);
    }

    for (i = 0; i < QTY_LED; i++) {
        CleanDataBuffer1();
        MeteorRainLightOutSetup(QTY_LED - i, MaxBright * 2 / 3, 0, MaxBright);
        LEDOutput();
        delay_ms(50);
    }

    for (i = 0; i < QTY_LED; i++) {
        CleanDataBuffer1();
        MeteorRainLightInSetup(i, MaxBright, 0, MaxBright);
        LEDOutput();
        delay_ms(24);
    }

    for (i = 0; i < QTY_LED; i++) {
        CleanDataBuffer1();
        MeteorRainLightOutSetup(QTY_LED - i, MaxBright, 0, MaxBright);
        LEDOutput();
        delay_ms(50);
    }

    for (i = 0; i < QTY_LED; i++) {
        CleanDataBuffer1();
        MeteorRainLightInSetup(i, MaxBright, 0, MaxBright * 2 / 3);
        LEDOutput();
        delay_ms(24);
    }

    for (i = 0; i < QTY_LED; i++) {
        CleanDataBuffer1();
        MeteorRainLightOutSetup(QTY_LED - i, MaxBright, 0, MaxBright * 2 / 3);
        LEDOutput();
        delay_ms(50);
    }

    for (i = 0; i < QTY_LED; i++) {
        CleanDataBuffer1();
        MeteorRainLightInSetup(i, MaxBright, 0, MaxBright / 3);
        LEDOutput();
        delay_ms(24);
    }

    for (i = 0; i < QTY_LED; i++) {
        CleanDataBuffer1();
        MeteorRainLightOutSetup(QTY_LED - i, MaxBright, 0, MaxBright / 3);
        LEDOutput();
        delay_ms(50);
    }

    return;
}

//LED Show Marquee 16-1 ----------------------------------------------
void ShowFullColor(void) {
    uint16_t i, j;

    CleanDataBuffer1();

    for (j = 0; j < QTY_LED; j++) {
        for (i = 0; i < Number_Colors; i++) {
            LEDBuf1[j][i] = FullColor[j][i];
        }
    }

    LEDOutput();
    delay_ms(10);
    return;
}


//Open  IIC ----------------------------------------------
void UI2C0_Init(uint32_t u32ClkSpeed) {
    UI2C_Open(UI2C0, u32ClkSpeed);
}

//Read Switch ----------------------------------------------
void ReadSwitch(void) {
    UI2C_Open(UI2C0, 100000);       								 //Open  IIC
    UI2C_WriteByte(UI2C0, 0x38, 0);
    SwitchVlaue[0] = UI2C_ReadByte(UI2C0, 0x38);
    UI2C_WriteByte(UI2C0, 0x39, 0);
    SwitchVlaue[1] = UI2C_ReadByte(UI2C0, 0x39);
    UI2C_Close(UI2C0);															//Close  IIC
}

//*************************************************************************
int32_t main(void) {
    /* Init System, IP clock and multi-function I/O. */
    M0A23OC_SYS_Init();
    M0A23OC_Pin_init();

    while (1) {
        ICCMD = 0x0cc00;
        ReadSwitch();

        if((SwitchVlaue[1] & 0x80) == 0) {
            ICCMD |= 0x2000;
            EnableGck();
        }
        else {
            ICCMD &= 0xdfff;
            DisableGck();
        }

        if((SwitchVlaue[1] & 0x40) == 0) {
            ICCMD |= 0x1000;
        }

        if((SwitchVlaue[1] & 0x20) == 0) {
            ICCMD |= 0x200;
        }

        if((SwitchVlaue[1] & 0x10) == 0) {
            ICCMD |= 0x100;
        }

        if((SwitchVlaue[1] & 0x08) == 0) {
            ICCMD |= 0x80;
        }

        if((SwitchVlaue[1] & 0x04) == 0) {
            ICCMD |= 0x40;
        }

        if((SwitchVlaue[1] & 0x02) == 0) {
            ICCMD |= 0x20;
        }

        if((SwitchVlaue[1] & 0x01) == 0) {
            ICCMD |= 0x10;
        }

        CleanDataBuffer1();
        LEDOutput();

        if((SwitchVlaue[0] & 0xff)  == 0xff) {
            ShowFullColor();
        }

        if((SwitchVlaue[0] & 0x01) == 0) {
            Show1();
        }

        if((SwitchVlaue[0] & 0x02) == 0) {
            Show2();
        }

        if((SwitchVlaue[0] & 0x04) == 0) {
            Show3();
        }

        if((SwitchVlaue[0] & 0x08) == 0) {
            Show4();
        }

        if((SwitchVlaue[0] & 0x10) == 0) {
            Show5();
        }

        if((SwitchVlaue[0] & 0x20) == 0) {
            Show6();
        }

        if((SwitchVlaue[0] & 0x40) == 0) {
            Show7();
        }

    }
}
